#ifndef _PTHREAD_H_
#define _PTHREAD_H_

#ifdef IDENT_STRING
static char rcsid_pcthreads_h[]
    = "$Header: /pdd/wssw/archives/MTX/rcs/mit/lib/pcthreads/pcthreads.h,v 1.7 1992/06/29 20:03:09 chiba Exp $";
#endif


#ifdef  USE_MONITER_MTX
#include <mach.h>
#endif

#include <mach/cthreads.h>

#define PTHREAD_PROCSYNC 1
#define PTHREAD_PROCASYNC 2

#define pthread_attr_default 3
#define pthread_mutexattr_default 4
#define pthread_condattr_default 3

#if 0
typedef cthread_t pthread_t;
typedef int pthread_attr_t;
typedef int pthread_mutexattr_t;
typedef int pthread_condattr_t;
typedef struct mutex pthread_mutex_t;
typedef struct condition pthread_cond_t;
typedef int pthread_key_t;
#else
#define pthread_t cthread_t
#define pthread_attr_t int 
#define pthread_mutexattr_t int 
#define pthread_condattr_t int
#define pthread_mutex_t struct mutex
#define pthread_cond_t struct condition
#define pthread_key_t int
#endif

#define DATAKEYS_MAX 5

void 	pthread_init(/*int mode*/ void);
int 	pthread_create(pthread_t *threadptr,pthread_attr_t attr,any_t func,any_t arg);
void 	pthread_exit(any_t *stat);
int 	pthread_detach(pthread_t *thread);
void 	pthread_yield();
pthread_t pthread_self();

int 	pthread_mutex_init(mutex_t m,int attr);
int 	pthread_mutex_trylock(mutex_t m);
int 	pthread_mutex_unlock(mutex_t m);
int 	pthread_mutex_lock(mutex_t m);

int 	pthread_mutexattr_create(pthread_mutexattr_t *attr);

int 	pthread_get_id();
void 	pthread_set_symname(any_t addr, char *name);
int 	pthread_cond_init(condition_t c,int attr);
int 	pthread_cond_signal(condition_t c);
int 	pthread_cond_broadcast(condition_t c);
int 	pthread_cond_wait(condition_t c,mutex_t m);
int 	pthread_condattr_create(pthread_condattr_t *attr);

int 	pthread_attr_create(pthread_attr_t *attr);
int 	pthread_key_create(pthread_key_t  *pKey, void (*destructor)());
int 	pthread_setspecific(pthread_key_t key, void *value);
int 	pthread_getspecific(pthread_key_t key, void **value);
#endif
